//+------------------------------------------------------------------+
//|                                             $LR_Angle_sample.mq4 |
//|                                                         Vladimir |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//      Linear Regression.mq4   tageiger
//+------------------------------------------------------------------+
#property indicator_chart_window

extern int period=0;
extern int width=2;
extern int LR_length=55;  
extern double k=1.0;


int init()
   {
   return(0);
   }
int deinit()
   { 
   ObjectDelete(period+"m "+LR_length+" TL"); 
   Comment("");
   return(0);
   }

int start()
   {
   ObjectDelete(period+"m "+LR_length+" TL");

   int start_bar=LR_length, end_bar=0;
   int n=start_bar-end_bar+1;

   double value=iClose(Symbol(),period,end_bar);
   double a,b,c;
   double sumy=value;
   double sumx=0.0;
   double sumxy=0.0;
   double sumx2=0.0;
   for(int i=1; i<n; i++)
     {
      value=iClose(Symbol(),period,end_bar+i);
      sumy+=value;
      sumxy+=value*i;
      sumx+=i;
      sumx2+=i*i;
     }
   c=sumx2*n-sumx*sumx;
//   if(c==0.0) return;
   if(c==0.0) c=0.0000001;
   b=(sumxy*n-sumx*sumy)/c;
   a=(sumy-sumx*b)/(n*1.0);
   double LR_price_2=a;
   double LR_price_1=a+b*n;

//    
   double anglelr=0.0;
   anglelr=-180*(MathArctan(k*b/Point)/3.1415926535);
   
Comment("          =  ",anglelr,"  .");

   ObjectCreate(period+"m "+LR_length+" TL",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1,Time[end_bar],LR_price_2);
   ObjectSet(period+"m "+LR_length+" TL",OBJPROP_COLOR,Red);
   ObjectSet(period+"m "+LR_length+" TL",OBJPROP_WIDTH,width);
   ObjectSet(period+"m "+LR_length+" TL",OBJPROP_RAY,false);     

return(0);
}
//+------------------------------------------------------------------+